<?php

namespace Protobuf\Binary\Platform;

/**
 * Implements platform specific encoding of negative values.
 *
 * Fabio B. Silva <fabio.bat.silva@gmail.com>
 */
interface NegativeEncoderInterface {

  /**
   * Encode a negative varint.
   *
   * @param int $value
   *   Value.
   *
   * @return array
   *   Varint.
   */
  public function encodeVarint($value);

  /**
   * Encode an integer as a fixed of 64bits.
   *
   * @param int $value
   *   Value.
   *
   * @return string
   *   Integer fixed.
   */
  public function encodeSfixed64($value);

}
