<?php

namespace Protobuf;

/**
 * Protocol buffer serializer.
 *
 * Fabio B. Silva <fabio.bat.silva@gmail.com>
 */
interface SerializerInterface {

  /**
   * Serializes the given message.
   *
   * @param \Protobuf\MessageInterface $message
   *   MessageInterface.
   *
   * @return \Protobuf\Stream
   *   Stream.
   */
  public function serialize(MessageInterface $message);

  /**
   * Deserializes the given data to the specified message.
   *
   * @param string $class
   *   Class.
   * @param \Protobuf\Stream|resource|string $stream
   *   Stream.
   *
   * @return \Protobuf\MessageInterface
   *   MessageInterface.
   */
  public function unserialize($class, $stream);

}
